
; *********************************************************************
; *                                                                   *
; *       BlitzBasic AddToBCA-File (Engine) V1.1 (BBC --> BCA)        *
; * ----------------------------------------------------------------- *
; *         Written in 2004 by Harald Wagner (AL90@Lycos.de)          *
; *                                                                   *
; *********************************************************************



Function AddToArchive(pack$,arc$)

; ---------- .BBC-File in Bank Laden -----------------------

pack2$="":l=0
If pack$<>"" Then l=FileSize(pack$)

If arc$<>"" And l>0
  fsize=FileSize(pack$)
  bank=CreateBank(fsize)
  r=ReadFile(pack$)
  ReadBytes(bank,r,0,fsize)
  CloseFile(r)

  For i=Len(pack$) To 1 Step -1 ; Path & Dir abhngen
    If Mid$(pack$,i,1)="\"
      pack2$=Mid$(pack$,i+1)
      pack$=pack2$
      Exit
    EndIf
  Next

  If pack2$=""
    RuntimeError "Invalid BBC-Name, Please Type Full Path+Name"
    Return -1
  EndIf

  pack2$=""
  If Upper$(Right$(pack$,4))<>".BBC" Then pack$=pack$+".BBC"
  v2=PeekInt(bank,0)

; ---------- .BCA-Archiv anlegen wenn nich Existent --------

  If FileType(arc$)=0
    w=WriteFile(arc$)
    WriteInt w,$00414342
    WriteInt w,0
    CloseFile(w)
  EndIf

; ---------- Prfen ob File .BCA-Archiv ist und .BBC-File anhngen -----

  l=FileSize(arc$)
  r=ReadFile(arc$)
  v=ReadInt(r)
  CloseFile(r)

  If v=$00414342 And v2=$00434242
    w=OpenFile(arc$)
    SeekFile(w,4)
    anzfiles=ReadInt(w)
    bbcname$=""

    If anzfiles>0
      For i=1 To anzfiles
        bbcname$=ReadString(w)
        bytes=ReadInt(w)
        pos=FilePos(w)+bytes
        SeekFile(w,pos)
        If Lower$(bbcname$)=Lower$(pack$) Then Exit
      Next

      If Lower$(bbcname$)=Lower$(pack$)
        RuntimeError "File is already in Archive!"
        Return -1
      EndIf

    EndIf

    If Lower$(bbcname$)<>Lower$(pack$)
      anzfiles=anzfiles+1
      SeekFile(w,4)
      WriteInt w,anzfiles
      SeekFile(w,l)
      WriteString w,pack$
      WriteInt w,fsize
      WriteBytes(bank,w,0,fsize)
    EndIf

    CloseFile(w)
  EndIf

  If v2<>$00434242
    RuntimeError "File is not a Packed BBC-File!"
    Return -1
  EndIf

  FreeBank bank
  Return 0

Else

  RuntimeError "BBC-File not Found!"
  Return -1

EndIf

End Function
