
; *********************************************************************
; *                                                                   *
; *            BlitzBasic File-DeCruncher (DLL-Engine) V1.3           *
; * ----------------------------------------------------------------- *
; *        Written in 2004-2005 by Harald Wagner (AL90@Lycos.de)      *
; *                                                                   *
; *********************************************************************



; Syntax for DeCrunch:
; --------------------

; DeCrunch(EngineDLL,PackFile,UnpackedFile,GUI[0-1])

; Examples: (With GUI and/or Without GUI)
; ---------------------------------------

; DeCrunch("C:\CruncherEngine.dll","C:\PackedFile.BBC","C:\UnpackedFile.XYZ",1)

; DeCrunch("C:\CruncherEngine.dll","C:\PackedFile.BBC","C:\UnpackedFile.XYZ",0)



Function DeCrunch(dll$,pack$,dest$,gui)
  bnk=CreateBank(1024)
  all$=pack$+Chr$(0)+dest$+Chr$(0)+Str$(gui)+Chr$(0)
  For x=0 To Len(all$)-1
    PokeByte bnk,x,Asc(Mid$(all$,x+1,1))
  Next
  CallDLL(dll$,"DeCrunch",bnk)
  FreeBank bnk
End Function
