
; *********************************************************************
; *                                                                   *
; *             BlitzBasic File-Cruncher (DLL-Engine) V1.3            *
; * ----------------------------------------------------------------- *
; *       Written in 2004-2005 by Harald Wagner (AL90@Lycos.de)       *
; *                                                                   *
; *********************************************************************



; Syntax for Crunch:
; ------------------

; Crunch(EngineDLL,OriginalFile,PackFile,Packrate[1-4],GUI[0-1])

; Examples: (With GUI and/or Without GUI)
; ---------------------------------------

; Crunch("C:\CruncherEngine.dll","C:\OriginalFile","C:\PackFile.BBC",4,1)

; Crunch("C:\CruncherEngine.dll","C:\OriginalFile","C:\PackFile.BBC",4,0)


Function Crunch(dll$,source$,dest$,packrate,gui)
  bnk=CreateBank(1024)
  all$=source$+Chr$(0)+dest$+Chr$(0)+Str$(packrate)+Chr$(0)+Str$(gui)+Chr$(0)
  For x=0 To Len(all$)-1
    PokeByte bnk,x,Asc(Mid$(all$,x+1,1))
  Next
  CallDLL(dll$,"Crunch",bnk)
  FreeBank bnk
End Function
