
; *********************************************************************
; *                                                                   *
; *            BlitzBasic File-Extractor  (DLL-Engine) V1.3           *
; * ----------------------------------------------------------------- *
; *        Written in 2004-2005 by Harald Wagner (AL90@Lycos.de)      *
; *                                                                   *
; *********************************************************************



; Syntax for ExtractFile:
; -----------------------

; ExtractFile(EngineDLL,ArchiveFile,PackFile,UnpackedFile,GUI[0-1])

; Examples: (With GUI and/or Without GUI)
; ---------------------------------------

; ExtractFile("C:\CruncherEngine.dll","C:\Archive.BCA","PackedFile-in-Archive.BBC","C:\UnpackedFile.XYZ",1)

; ExtractFile("C:\CruncherEngine.dll","C:\Archive.BCA","PackedFile-in-Archive.BBC","C:\UnpackedFile.XYZ",0)



Function ExtractFile(dll$,arc$,pack$,dest$,gui)
  bnk=CreateBank(1024)
  all$=arc$+Chr$(0)+pack$+Chr$(0)+dest$+Chr$(0)+Str$(gui)+Chr$(0)
  For x=0 To Len(all$)-1
    PokeByte bnk,x,Asc(Mid$(all$,x+1,1))
  Next
  CallDLL(dll$,"ExtractFile",bnk)
  FreeBank bnk
End Function
