
; *********************************************************************
; *                                                                   *
; *             BlitzBasic GetBBC-Name$ (DLL-Engine) V1.3             *
; * ----------------------------------------------------------------- *
; *          Written in 2004 by Harald Wagner (AL90@Lycos.de)         *
; *                                                                   *
; *********************************************************************



; Syntax for GetBBCName$:
; -----------------------

; GetBBCName$(EngineDLL,ArchiveFile,FileNumberID)

; Example:
; --------

; File$ = GetBBCName$("C:\CruncherEngine.dll","C:\Archive.BCA",3)



Function GetBBCName$(dll$,arc$,idnumber)
  bnk=CreateBank(1024)
  all$=arc$+Chr$(0)+Str$(idnumber)+Chr$(0)
  For x=0 To Len(all$)-1
    PokeByte bnk,x,Asc(Mid$(all$,x+1,1))
  Next
  CallDLL(dll$,"GetBBCName",bnk)
  bbcname$=""
  For i=0 To 1024
    byte=PeekByte(bnk,i)
    If byte=0 Then Exit
    bbcname$=bbcname$+Chr$(byte)
  Next
  FreeBank bnk
  Return bbcname$
End Function
