
; *********************************************************************
; *                                                                   *
; *            BlitzBasic GetNumberFiles  (DLL-Engine) V1.3           *
; * ----------------------------------------------------------------- *
; *          Written in 2004 by Harald Wagner (AL90@Lycos.de)         *
; *                                                                   *
; *********************************************************************



; Syntax for GetNumberFiles:
; --------------------------

; GetNumberFiles(EngineDLL,ArchiveFile)

; Example:
; --------

; NumFiles = GetNumberFiles("C:\CruncherEngine.dll","C:\Archive.BCA")



Function GetNumberFiles(dll$,arc$)
  bnk=CreateBank(1024)
  all$=arc$+Chr$(0)
  For x=0 To Len(all$)-1
    PokeByte bnk,x,Asc(Mid$(all$,x+1,1))
  Next
  CallDLL(dll$,"GetNumberFiles",bnk)
  numfiles=PeekInt(bnk,0)
  FreeBank bnk
  Return numfiles
End Function
