
; *********************************************************************
; *                                                                   *
; *           BlitzBasic RemoveFromBCA-File  (Engine) V1.0            *
; * ----------------------------------------------------------------- *
; *         Written in 2004 by Harald Wagner (AL90@Lycos.de)          *
; *                                                                   *
; *********************************************************************



Function RemoveFromArchive(pack$,arc$)

If arc$<>"" Then l=FileSize(arc$)

If pack$<>"" And l>0
  r=ReadFile(arc$)
  vers=ReadInt(r)

  If vers<>$00414342
    RuntimeError "File is not a BCA-Archive!"
    CloseFile(r)
    Return -1
  EndIf

  anzfiles=ReadInt(r)
  CloseFile(r)
  tmp$=SystemProperty$("tempdir")
  If Right$(tmp$,1)<>"\" Then tmp$=tmp$+"\"
  tmp$=tmp$+"BCA-TempFile.tmp"

  If anzfiles>0
    anzfiles2=anzfiles
    CopyFile arc$,tmp$
    r=ReadFile(tmp$)
    w=WriteFile(arc$)
    WriteInt w,$00414342
    WriteInt w,0
    SeekFile(r,8)
    For i=1 To anzfiles
      bbcname$=ReadString(r)
      bytes=ReadInt(r)
      If Lower$(bbcname$)<>Lower$(pack$)
        WriteString w,bbcname$
        WriteInt w,bytes
        bnk=CreateBank(bytes)
        ReadBytes(bnk,r,0,bytes)
        WriteBytes(bnk,w,0,bytes)
        FreeBank bnk
      Else
        pos=FilePos(r)+bytes
        SeekFile(r,pos)
        anzfiles2=anzfiles2-1
      EndIf
    Next
    SeekFile(w,4)
    WriteInt w,anzfiles2
    CloseFile(r)
    CloseFile(w)
    DeleteFile tmp$
  EndIf

EndIf

End Function
