
' *************************************************************
' *                                                           *
' *          BlitzMax File-DeCruncher (Engine) V1.2           *
' * --------------------------------------------------------- *
' *     Written in 2005 by Harald Wagner (AL90@Lycos.de)      *
' *                                                           *
' *************************************************************



Function DeCrunch(pack$,dest$)

Local b,z,l,i,origsize,origoffset,destoffset,pak,vers,packs,blocksize
Local blocks,rest,loop,count,pos,einzelsumme,einzelpeek,einzelpoke
Local scanvalue,bytes,neu

z=0
l=FileSize(pack$)-9
origsize=l
origoffset=0
destoffset=0
pak=ReadFile(pack$)
vers=Readint(pak)
packs=ReadByte(pak)
blocksize=Readint(pak)
If vers<>$00434242 ' Not a Supported Packfile
  CloseFile(pak)
  Return -1
EndIf

Local bnk1:TBank=CreateBank(blocksize+1)
Local bnk2:TBank=CreateBank(blocksize+1)
Local scan:TBank=CreateBank(128)
Local origbnk:TBank=CreateBank(l+10000)
Local destbnk:TBank=CreateBank(l+10000)
origbnk.Read(pak,0,l) ' Load PakedFile into MEMORY!
CloseFile(pak)
blocks=l/blocksize;rest=l-(blocks*blocksize)

Repeat
  z=z+1
  origoffset=0
  destoffset=0
  l=origbnk.PeekInt(0)
  If l>origbnk.Size() Then origbnk.Resize(l+10000)
  If l>destbnk.Size() Then destbnk.Resize(l+10000)
  origoffset=origoffset+4
  blocks=l/blocksize;rest=l-(blocks*blocksize)

  '
  ' Datei entpacken
  '

  For loop=1 To blocks
    count=0;pos=0
    scanvalue=origbnk.PeekByte(origoffset)
    origoffset=origoffset+1

    If scanvalue=0
       CopyBank origbnk:TBank,origoffset,bnk1:TBank,1,blocksize
       origoffset=origoffset+blocksize
       CopyBank bnk1:TBank,1,destbnk:TBank,destoffset,blocksize
       destoffset=destoffset+blocksize
    EndIf

    If scanvalue<>0
      bytes=origbnk.PeekByte(origoffset)
      origoffset=origoffset+1
      CopyBank(origbnk:TBank,origoffset,scan:TBank,1,bytes)
      origoffset=origoffset+bytes

      Repeat
        b=origbnk.PeekByte(origoffset)
        origoffset=origoffset+1

        If b=scanvalue
          If einzelsumme>0
            CopyBank origbnk:TBank,einzelpeek,bnk2:TBank,einzelpoke,einzelsumme
            einzelsumme=0
          EndIf
          CopyBank scan:TBank,1,bnk2:TBank,pos+1,bytes
          count=count+bytes
          pos=pos+bytes
          If count=>blocksize Then Exit
        Else
          count=count+1
          pos=pos+1
          If einzelsumme=0 Then einzelpoke=pos;einzelpeek=origoffset-1
          einzelsumme=einzelsumme+1
          If count=>blocksize Then Exit
        EndIf

      Until count=>blocksize

      If einzelsumme>0
        CopyBank origbnk:TBank,einzelpeek,bnk2:TBank,einzelpoke,einzelsumme
        einzelsumme=0
      EndIf

      CopyBank bnk2:TBank,1,destbnk:TBank,destoffset,pos
      destoffset=destoffset+pos
    EndIf
  Next

  If rest>0
    CopyBank origbnk:TBank,origoffset,destbnk:TBank,destoffset,rest
    origoffset=origoffset+rest
    destoffset=destoffset+rest
  EndIf

  CopyBank destbnk:TBank,0,origbnk:TBank,0,destoffset
  origsize=destoffset

Until z=packs

neu=WriteFile(dest$)
destbnk.Write(neu,0,origsize)
CloseFile(neu)
bnk1=Null
bnk2=Null
scan=Null
origbnk=Null
destbnk=Null
FlushMem
End Function
