
' *************************************************************
' *                                                           *
' *          BlitzMax File-Extractor (Engine) V1.2            *
' * --------------------------------------------------------- *
' *     Written in 2005 by Harald Wagner (AL90@Lycos.de)      *
' *                                                           *
' *************************************************************



Function ExtractFile(arc$,pack$,dest$)

Local tst$,offset,offset1,vers,anzfiles,bbcname$,pos,origsize
Local origoffset,destoffset,packs,blocksize
Local rest,loop,count,scanvalue,bytes,neu
Local einzelsumme,einzelpeek,einzelpoke
Local blocks,strgsize,b,i,r,l,x,z

tst$="Important! - Do not change this Line, its used for SingleFile-Creation!"
offset=0
offset1=Int(tst$)
If offset1<0 Then offset1=0

If FileType(arc$)=0 ' Archive Existiert nicht - .BCA aus EXE-File ermitteln.
  arc$=AppFile$
  offset=offset1
  If offset=0 Then arc$=""
EndIf

If arc$=""
  RuntimeError ".BCA ArchiveFile not Found!"
  End
EndIf

r=ReadFile(arc$)
If offset>0 Then SeekStream(r,offset)
vers=Readint(r)

If vers<>$00414342 ' Not a Supported BCA-ArchiveFile
  CloseFile(r)
  Return -1
EndIf

anzfiles=Readint(r)

For i=1 To anzfiles
  strgsize=Readint(r)
  bbcname$=""
  For x=1 To strgsize
    b=ReadByte(r)
    bbcname$=bbcname$+Chr(b)
  Next
  l=Readint(r)
  If Lower$(bbcname$)=Lower$(pack$) Then Exit
  pos=StreamPos(r)+l
  SeekStream(r,pos)
Next

If Lower$(bbcname$)<>Lower$(pack$)
  CloseFile(r)
  Return -1
EndIf

vers=Readint(r)
l=l-9;origsize=l
origoffset=0
destoffset=0
packs=ReadByte(r)
blocksize=Readint(r)

Local bnk1:TBank=CreateBank(blocksize+1)
Local bnk2:TBank=CreateBank(blocksize+1)
Local scan:TBank=CreateBank(128)
Local origbnk:TBank=CreateBank(l+10000)
Local destbnk:TBank=CreateBank(l+10000)
origbnk.Read(r,0,l) ' Load PakedFile into MEMORY!
CloseFile(r)
blocks=l/blocksize;rest=l-(blocks*blocksize);z=0

Repeat
  z=z+1
  origoffset=0
  destoffset=0
  l=origbnk.PeekInt(0)
  If l>origbnk.Size() Then origbnk.Resize(l+10000)
  If l>destbnk.Size() Then destbnk.Resize(l+10000)
  origoffset=origoffset+4
  blocks=l/blocksize;rest=l-(blocks*blocksize)

  '
  ' Datei entpacken
  '

  For loop=1 To blocks
    count=0;pos=0
    scanvalue=origbnk.PeekByte(origoffset)
    origoffset=origoffset+1

    If scanvalue=0
       CopyBank origbnk:TBank,origoffset,bnk1:TBank,1,blocksize
       origoffset=origoffset+blocksize
       CopyBank bnk1:TBank,1,destbnk:TBank,destoffset,blocksize
       destoffset=destoffset+blocksize
    EndIf

    If scanvalue<>0
      bytes=origbnk.PeekByte(origoffset)
      origoffset=origoffset+1
      CopyBank(origbnk:TBank,origoffset,scan:TBank,1,bytes)
      origoffset=origoffset+bytes

      Repeat
        b=origbnk.PeekByte(origoffset)
        origoffset=origoffset+1

        If b=scanvalue
          If einzelsumme>0
            CopyBank origbnk:TBank,einzelpeek,bnk2:TBank,einzelpoke,einzelsumme
            einzelsumme=0
          EndIf
          CopyBank scan:TBank,1,bnk2:TBank,pos+1,bytes
          count=count+bytes
          pos=pos+bytes
          If count=>blocksize Then Exit
        Else
          count=count+1
          pos=pos+1
          If einzelsumme=0 Then einzelpoke=pos;einzelpeek=origoffset-1
          einzelsumme=einzelsumme+1
          If count=>blocksize Then Exit
        EndIf

      Until count=>blocksize

      If einzelsumme>0
        CopyBank origbnk:TBank,einzelpeek,bnk2:TBank,einzelpoke,einzelsumme
        einzelsumme=0
      EndIf

      CopyBank bnk2:TBank,1,destbnk:TBank,destoffset,pos
      destoffset=destoffset+pos
    EndIf
  Next

  If rest>0
    CopyBank origbnk:TBank,origoffset,destbnk:TBank,destoffset,rest
    origoffset=origoffset+rest
    destoffset=destoffset+rest
  EndIf

  CopyBank destbnk:TBank,0,origbnk:TBank,0,destoffset
  origsize=destoffset

Until z=packs

neu=WriteFile(dest$)
destbnk.Write(neu,0,origsize)
CloseFile(neu)
bnk1=Null
bnk2=Null
scan=Null
origbnk=Null
destbnk=Null
FlushMem
End Function
